/*****************************************************************************

Copyright 2001-2050 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2006/07/30 17:35:00

Borg Daemon
   Classe responsavel por executar as mensagens recebidas e envio
   do resutado pelo processo requerente. Este eh o daemon propriamente
   dito.

******************************************************************************/

import java.io.*;
import java.net.*;
import java.util.*;

public class Borgd extends Thread {
	private ServerSocket sock; // Socket do servidor
	static public int porta = 4410; // Porta para conexao padrao

	// Constructor, inicializador do processo em forma de thread
	public Borgd(int p) {
		super();
		if (p != 0) porta = p;
		try {
			sock = new ServerSocket(porta);
			System.out.println("Borg Daemon rodando...");
		} catch (IOException e) {
			System.out.println("Erro: nao foi possivel criar o socket.");
			System.exit(1);
		}
	}

	// Execucao
	public void run () {
		Socket conexao = null;
		boolean sair = false;
		// Fica esperando o recebimento de mensagens
		while (!sair) {
		if (sock == null) return;
			try {
				conexao = sock.accept();
				// Recebendo mensagem
				BufferedReader in = new BufferedReader(
					new InputStreamReader(conexao.getInputStream()));
				String mensagem = in.readLine();
				System.out.println("RECEBE DE  ["+ conexao.getInetAddress() +
					":" + porta + "]: " + mensagem);
				// executando a mensagem
				mensagem = executar(mensagem);
				// Enviando a resposta
				BufferedOutputStream bos = new BufferedOutputStream(
					conexao.getOutputStream());
				PrintWriter os = new PrintWriter(bos, false);
				System.out.println("ENVIA PARA ["+ conexao.getInetAddress() +
					":" + porta + "]: " + mensagem);
				os.println(mensagem);
				os.flush();
				os.close();
			} catch (IOException e) {
				System.out.println("Erro: nao foi possivel conectar ao cliente.");
        	    System.exit(1);
			}
		}
	}

	String executar(String msg) {
		String resultado = "null";
		StringTokenizer split = new StringTokenizer(msg, " ");
		// Verifica qual eh o comando a executar, 1a palavra da mensagem
		String comando = split.nextToken();
		// Executa o comando de fatorial
		if (comando.indexOf("fatorial") >= 0){
			int a = Integer.parseInt(split.nextToken());
			int b = Integer.parseInt(split.nextToken());
			long c = 1;
			for (int i = a; i <= b; i++) {
				c *= i;
			}
			resultado = "" + c;
		}
		// Pode ter outros comandos, colocando-se aqui
		// if-then-else aninhados...
		return resultado;
	}

	// Programa principal
	public static void main(String[] arguments) {
		// Pega o numero da porta de conexao, se nao for a padrao 4410
		int porta = 0;
		if (arguments.length == 1) {
			porta = Integer.parseInt(arguments[0]);
		} else if (arguments.length > 1) {
			System.out.println("Utilize: java Borgd [porta]");
			return;
		}
		Borgd daemon = new Borgd(porta);
		daemon.start();
	}
}
